﻿using System;
using System.Runtime.InteropServices;
using System.Threading;
using System.Threading.Tasks;
using WordPressPCL;
using WordPressPCL.Models;

namespace WordPressTest
{
	class Program
	{
		static void Main(string[] args)
		{
			CreatePosttest("http://blogdemo.com", "demouser","demopwd");
		}
		
		[RGiesecke.DllExport.DllExport]
		public static int CSharpADDsample(int a, int b)
        {
			return a + b;
        }

		[RGiesecke.DllExport.DllExport]
		public static int CreatePosttest([MarshalAs(UnmanagedType.LPWStr)] string URL, [MarshalAs(UnmanagedType.LPWStr)] string username, [MarshalAs(UnmanagedType.LPWStr)] string password)
		{
			int res = 0;
			try
			{
				WordPressClient client = new WordPressClient(URL + "/wp-json");
				client.AuthMethod = AuthMethod.JWT;
				client.RequestJWToken(username, password).Wait();

				if (client.IsValidJWToken().GetAwaiter().GetResult())
				{
					var post = new Post
					{
						Title = new Title("New post test"),
						Content = new Content("Content for new post.")
					};
					client.Posts.Create(post).Wait();
					res = 1;
				}
			}
			catch (Exception e)
			{
				Console.WriteLine("Error:" + e.Message);
				res = 0;
			}
			return res;
		}
	}
}